import java.util.*;
import org.chocosolver.solver.Model;

public class Resource {
    String id;
    ArrayList<Operation> operations;
    ArrayList<Decision> decisions;
    Model model;

    Resource(String id,Model model){
	this.id    = id;
	operations = new ArrayList<Operation>();
	decisions  = new ArrayList<Decision>();
	this.model = model;
    }
    
    void add(Operation op){
	int n = operations.size();
	for (int i=0;i<n;i++){
	    Operation op_i = operations.get(i);
	    Decision decision = new Decision(model,op_i,op);
	    decisions.add(decision);
	    model.ifThen(model.arithm(decision,"=",0),op_i.before(op)); // decision = 0 -> op_i before op
	    model.ifThen(model.arithm(decision,"=",1),op.before(op_i)); // decision = 1 -> op before op_i
	}
	operations.add(op);
    }
    
    public String toString(){return "Res: " + id + 
	                            " NoOps: " + operations.size() + 
                                    " NoDecVars: " + decisions.size();}

}
